/**
* DevExtreme (core/component.d.ts)
* Version: 21.1.0 (build 20336-2119)
* Build date: Tue Dec 01 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
  dxElement
} from './element';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ComponentOptions<T = Component> {
  /**
   */
  onDisposing?: ((e: { component?: T }) => any);
  /**
   */
  onInitialized?: ((e: { component?: T, element?: dxElement }) => any);
  /**
   */
  onOptionChanged?: ((e: { component?: T, name?: string, fullName?: string, value?: any }) => any);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class Component {
  constructor(options?: ComponentOptions);
  /**
   */
  beginUpdate(): void;
  /**
   */
  endUpdate(): void;
  /**
   */
  instance(): this;
  /**
   */
  off(eventName: string): this;
  /**
   */
  off(eventName: string, eventHandler: Function): this;
  /**
   */
  on(eventName: string, eventHandler: Function): this;
  /**
   */
  on(events: any): this;
  /**
   */
  option(): any;
  /**
   */
  option(optionName: string): any;
  /**
   */
  option(optionName: string, optionValue: any): void;
  /**
   */
  option(options: any): void;
  /**
   */
  resetOption(optionName: string): void;

  _createActionByOption(optionName: string, config: object): Function;
  _dispose(): void;
  _getDefaultOptions(): object;
  _init(): void;
  _optionChanged(args: { name: string; value: unknown }): void;
}
