/**
* DevExtreme (ui/lookup.d.ts)
* Version: 21.1.0 (build 20336-2119)
* Build date: Tue Dec 01 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    animationConfig
} from '../animation/fx';

import {
    positionConfig
} from '../animation/position';

import '../jquery_augmentation';

import {
    dxElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    event
} from '../events/index';

import dxDropDownList, {
    dxDropDownListOptions
} from './drop_down_editor/ui.drop_down_list';

import {
    dxPopoverOptions
} from './popover';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLookupOptions extends dxDropDownListOptions<dxLookup> {
    /**
     * @deprecated
     */
    animation?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hide?: animationConfig,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      show?: animationConfig
    };
    /**
     */
    applyButtonText?: string;
    /**
     */
    applyValueMode?: 'instantly' | 'useButtons';
    /**
     */
    cancelButtonText?: string;
    /**
     */
    cleanSearchOnOpening?: boolean;
    /**
     */
    clearButtonText?: string;
    /**
     * @deprecated
     */
    closeOnOutsideClick?: boolean | ((event: event) => boolean);
    /**
     */
    fieldTemplate?: template | ((selectedItem: any, fieldElement: dxElement) => string | Element | JQuery);
    /**
     */
    focusStateEnabled?: boolean;
    /**
     * @deprecated
     */
    fullScreen?: boolean;
    /**
     */
    groupTemplate?: template | ((itemData: any, itemIndex: number, itemElement: dxElement) => string | Element | JQuery);
    /**
     */
    grouped?: boolean;
    /**
     */
    nextButtonText?: string;
    /**
     */
    onPageLoading?: ((e: { component?: dxLookup, element?: dxElement, model?: any }) => any);
    /**
     */
    onPullRefresh?: ((e: { component?: dxLookup, element?: dxElement, model?: any }) => any);
    /**
     */
    onScroll?: ((e: { component?: dxLookup, element?: dxElement, model?: any, event?: event, scrollOffset?: any, reachedLeft?: boolean, reachedRight?: boolean, reachedTop?: boolean, reachedBottom?: boolean }) => any);
    /**
     * @deprecated
     */
    onTitleRendered?: ((e: { component?: dxLookup, element?: dxElement, model?: any, titleElement?: dxElement }) => any);
    /**
     */
    onValueChanged?: ((e: { component?: dxLookup, element?: dxElement, model?: any, value?: any, previousValue?: any, event?: event }) => any);
    /**
     */
    pageLoadMode?: 'nextButton' | 'scrollBottom';
    /**
     */
    pageLoadingText?: string;
    /**
     */
    placeholder?: string;
    /**
     * @deprecated
     */
    popupHeight?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    popupWidth?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    position?: positionConfig;
    /**
     */
    pullRefreshEnabled?: boolean;
    /**
     */
    pulledDownText?: string;
    /**
     */
    pullingDownText?: string;
    /**
     */
    refreshingText?: string;
    /**
     */
    searchEnabled?: boolean;
    /**
     */
    searchPlaceholder?: string;
    /**
     * @deprecated
     */
    shading?: boolean;
    /**
     */
    showCancelButton?: boolean;
    /**
     */
    showClearButton?: boolean;
    /**
     * @deprecated
     */
    showPopupTitle?: boolean;
    /**
     * @deprecated
     */
    title?: string;
    /**
     * @deprecated
     */
    titleTemplate?: template | ((titleElement: dxElement) => string | Element | JQuery);
    /**
     */
    useNativeScrolling?: boolean;
    /**
     */
    usePopover?: boolean;
    /**
     */
    dropDownCentered?: boolean;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    dropDownOptions?: dxPopoverOptions;

}
/**
 */
export default class dxLookup extends dxDropDownList {
    constructor(element: Element, options?: dxLookupOptions)
    constructor(element: JQuery, options?: dxLookupOptions)
}

declare global {
interface JQuery {
    dxLookup(): JQuery;
    dxLookup(options: "instance"): dxLookup;
    dxLookup(options: string): any;
    dxLookup(options: string, ...params: any[]): any;
    dxLookup(options: dxLookupOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxLookupOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxLookupOptions;
