/**
* DevExtreme (ui/responsive_box.d.ts)
* Version: 21.1.0 (build 20336-2119)
* Build date: Tue Dec 01 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxResponsiveBoxOptions extends CollectionWidgetOptions<dxResponsiveBox> {
    /**
     */
    cols?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      baseSize?: number | 'auto',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      ratio?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      screen?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shrink?: number
    }>;
    /**
     */
    dataSource?: string | Array<string | dxResponsiveBoxItem | any> | DataSource | DataSourceOptions;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    items?: Array<string | dxResponsiveBoxItem | any>;
    /**
     */
    rows?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      baseSize?: number | 'auto',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      ratio?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      screen?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shrink?: number
    }>;
    /**
     */
    screenByWidth?: Function;
    /**
     */
    singleColumnScreen?: string;
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 */
export default class dxResponsiveBox extends CollectionWidget {
    constructor(element: Element, options?: dxResponsiveBoxOptions)
    constructor(element: JQuery, options?: dxResponsiveBoxOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxResponsiveBoxItem extends CollectionWidgetItem {
    /**
     */
    location?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      col?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      colspan?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      row?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      rowspan?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      screen?: string
    } | Array<{ col?: number, colspan?: number, row?: number, rowspan?: number, screen?: string }>;
}

declare global {
interface JQuery {
    dxResponsiveBox(): JQuery;
    dxResponsiveBox(options: "instance"): dxResponsiveBox;
    dxResponsiveBox(options: string): any;
    dxResponsiveBox(options: string, ...params: any[]): any;
    dxResponsiveBox(options: dxResponsiveBoxOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxResponsiveBoxOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxResponsiveBoxOptions;
