/**
* DevExtreme (ui/validation_engine.d.ts)
* Version: 21.1.0 (build 20336-2119)
* Build date: Tue Dec 01 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import {
    dxValidationGroupResult
} from './validation_group';

/**
 */
export default class validationEngine {
    /**
     */
    static getGroupConfig(): any;
    /**
     */
    static getGroupConfig(group: string | any): any;
    /**
     */
    static registerModelForValidation(model: any): void;
    /**
     */
    static resetGroup(): void;
    /**
     */
    static resetGroup(group: string | any): void;
    /**
     */
    static unregisterModelForValidation(model: any): void;
    /**
     */
    static validateGroup(): dxValidationGroupResult;
    /**
     */
    static validateGroup(group: string | any): dxValidationGroupResult;
    /**
     */
    static validateModel(model: any): any;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface AsyncRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    reevaluate?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
    /**
     */
    validationCallback?: ((options: { value?: string | number, rule?: any, validator?: any, data?: any, column?: any, formItem?: any }) => Promise<any> | JQueryPromise<any>);
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface CompareRule {
    /**
     */
    comparisonTarget?: (() => any);
    /**
     */
    comparisonType?: '!=' | '!==' | '<' | '<=' | '==' | '===' | '>' | '>=';
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    reevaluate?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface CustomRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    reevaluate?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
    /**
     */
    validationCallback?: ((options: { value?: string | number, rule?: any, validator?: any, data?: any, column?: any, formItem?: any }) => boolean);
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EmailRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface NumericRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface PatternRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    message?: string;
    /**
     */
    pattern?: RegExp | string;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface RangeRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    max?: Date | number;
    /**
     */
    message?: string;
    /**
     */
    min?: Date | number;
    /**
     */
    reevaluate?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface RequiredRule {
    /**
     */
    message?: string;
    /**
     */
    trim?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface StringLengthRule {
    /**
     */
    ignoreEmptyValue?: boolean;
    /**
     */
    max?: number;
    /**
     */
    message?: string;
    /**
     */
    min?: number;
    /**
     */
    trim?: boolean;
    /**
     */
    type?: 'required' | 'numeric' | 'range' | 'stringLength' | 'custom' | 'compare' | 'pattern' | 'email' | 'async';
}
